<?php

/**
 * Gpealtesalario
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 12/04/2011 11:06:56 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Gpealtesalario extends DaoGpeAltesalario
{


    /**
     * Retorna alteracao salarial por vinculo.
     *
     * @param integer $nrOrg      Numero da Organizacao de Trabalho.
     * @param integer $nrvinculom Numero do Vinculo.
     *
     * @return GpealtesalarioEntity
     *
     * @author alessandrobartels
     */
    public static function retornaAlteSalario($nrOrg, $nrvinculom){
        $alteSalario = self::getObjectsByWhere(
            ' NRORG = ?
              AND NRVINCULOM = ?',
            array(
             $nrOrg, $nrvinculom,
            ),
            'DTALTESALARIO'
        );
        return $alteSalario;
    }


    /**
     * Retorna um array de instancias de GpealtesalarioEntity.
     *
     * @param integer 	 $nrOrg			 Numero da organizacao de trabalho.
     * @param TkDateTime $dtAlterSalario Data de alteracao de salario.
     * @param integer    $nrVinculom 	 Numero do vinculo.
     * @param integer 	 $nrModalidade   Numero da modalidade.
     *
     * @return GpealtesalarioEntity
     *
     * @author alessandrobartels - 09/12/11 - OK
     */
    public static function retornaAlteSalarioAtualPorVinculoModalidade(
         $nrOrg, TkDateTime $dtAlterSalario, $nrVinculom, $nrModalidade
    ){
        /* $db = TkDb::singleton(); */
        $db = \Setforms2\Runtime\Connection::getInstance();
        $sql = 'SELECT *
		 		FROM GPE_ALTESALARIO EXT_ALTESALARIO
		 		WHERE DTALTESALARIO IN (
  					SELECT MAX(SUB_ALTESALARIO.DTALTESALARIO) DTALTESALARIO
  					FROM GPE_ALTESALARIO SUB_ALTESALARIO
  					WHERE SUB_ALTESALARIO.DTALTESALARIO <= \''.$dtAlterSalario.'\'
    				AND EXT_ALTESALARIO.NRORG = SUB_ALTESALARIO.NRORG
    				AND EXT_ALTESALARIO.NRVINCULOM = SUB_ALTESALARIO.NRVINCULOM
    				AND EXT_ALTESALARIO.NRTPMODALIDSAL = SUB_ALTESALARIO.NRTPMODALIDSAL
  		 		)
		 		AND EXT_ALTESALARIO.NRORG = '.$nrOrg.'
		 		AND EXT_ALTESALARIO.NRVINCULOM = '.$nrVinculom.'
		 		AND EXT_ALTESALARIO.NRTPMODALIDSAL = '.$nrModalidade.
                    'ORDER BY EXT_ALTESALARIO.DTALTESALARIO,
                    EXT_ALTESALARIO.NROCORRENCIA';

        $resultado = $db->fetchAll($sql);
        $alteSalario = self::createObjectsFromArray($resultado);
        return $alteSalario;
    }


    /**
     * Retorna alteracao salarial por vinculo em uma data especifica.
     *
     * @param integer    $nr_org       Numero da Orgnizacao de Trabalho.
     * @param integer    $nr_vinculo   Numero do Vinculo.
     * @param TkDateTime $dt_alteracao Data da alteracao salarial.
     *
     * @return GpealtesalarioEntity
     *
     * @author brunofeliciano
     */
    public static function retornaAlteraSalarioPorData($nr_org, $nr_vinculo, TkDateTime $dt_alteracao){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
             AND NRVINCULOM = ?
             AND DTALTESALARIO = ?',
            array(
             $nr_org, $nr_vinculo, $dt_alteracao->toString(TkDateTime::FORMAT_DATE),
            ),
            'DTALTESALARIO, NROCORRENCIA'
        );
        return $resultado;
    }


}